diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/buttons.qc qc/buttons.qc
--- qc-ori/buttons.qc	Fri Aug 16 20:15:23 1996
+++ qc/buttons.qc	Sun Aug 18 20:41:45 1996
@@ -55,6 +55,7 @@
 {
 	if (other.classname != "player")
 		return;
+	if (other.player_flag & PLAYER_IS_OBSERVER) return; //#jp#(Observer)
 	self.enemy = other;
 	button_fire ();
 };
diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/client.qc qc/client.qc
--- qc-ori/client.qc	Fri Aug 16 20:15:23 1996
+++ qc/client.qc	Sun Aug 18 20:41:45 1996
@@ -53,6 +53,7 @@
 	parm7 = self.ammo_cells;
 	parm8 = self.weapon;
 	parm9 = self.armortype * 100;
+        parm16 = self.player_flag; //#jp#(PlayerFlag)
 };
 
 void() SetNewParms =
@@ -66,10 +67,14 @@
 	parm6 = 0;
 	parm8 = 1;
 	parm9 = 0;
+        parm16 = 0; //#jp#(PlayerFlag)
 };
 
 void() DecodeLevelParms =
 {
+        self.player_flag = parm16;			//#jp#(PlayerFlag)
+        self.skin = (self.player_flag & 65280)/256;	//#jp#(Skin)
+
 	if (serverflags)
 	{
 		if (world.model == "maps/start.bsp")
@@ -143,6 +148,7 @@
 // skip any text in deathmatch
 	if (deathmatch)
 	{
+		MapQueueChooseMap(); //#jp#(MapQueue)
 		GotoNextMap ();
 		return;
 	}
@@ -343,7 +349,9 @@
 	if (coop)
 	{
 		// make a copy of the dead body for appearances sake
+if (!(self.player_flag & PLAYER_IS_OBSERVER)) {//#jp#(Observer)
 		CopyToBodyQue (self);
+}//#jp#(Observer)
 		// get the spawn parms as they were at level start
 		setspawnparms (self);
 		// respawn		
@@ -352,9 +360,12 @@
 	else if (deathmatch)
 	{
 		// make a copy of the dead body for appearances sake
+if (!(self.player_flag & PLAYER_IS_OBSERVER)) {//#jp#(Observer)
 		CopyToBodyQue (self);
+}//#jp#(Observer)
 		// set default spawn parms
 		SetNewParms ();
+		parm16 = self.player_flag; //#jp#(PlayerFlag)
 		// respawn		
 		PutClientInServer ();
 	}
@@ -379,6 +390,8 @@
 	set_suicide_frame ();
 	self.modelindex = modelindex_player;
 	self.frags = self.frags - 2;	// extra penalty
+	RankCountEvent(self,RANK_SUICIDE);	//#jp#(Rank)
+	if (KickSuicider(self)) return;		//#jp#(KickSuicider)
 	respawn ();
 };
 
@@ -496,6 +509,20 @@
 	
 	self.view_ofs = '0 0 22';
 
+if (!self.kick_suicider_lasttime)				//#jp#(KickSuicider)
+   self.kick_suicider_lasttime = time - 100000;			//#jp#(KickSuicider)
+
+if (!self.player_flag) {					//#jp#(PlayerFlag)
+   PlayerFlagSetFlag(self,PLAYER_IS_CLIENT);			//#jp#(PlayerFlag)
+   PlayerFlagSetFlag(self,PLAYER_IS_OBSERVER);			//#jp#(Observer)
+   self.observer_status = OBSERVER_BECOME_OBSERVER;		//#jp#(Observer)
+}								//#jp#(PlayerFlag)
+
+if (self.observer_status & OBSERVER_BECOME_OBSERVER) {		//#jp#(Observer)
+   ObserverBecomeObserver(self);				//#jp#(Observer)
+   return;							//#jp#(Observer)
+}								//#jp#(Observer)
+
 	player_stand1 ();
 	
 	if (deathmatch || coop)
@@ -654,6 +681,7 @@
 	}
 
 	nextmap = o.map;
+	MapQueueChooseMap(); //#jp#(MapQueue)
 	
 	if (o.nextthink < time)
 	{
@@ -737,6 +765,11 @@
 		return;
 	}
 
+   // check if player turned into observer //#jp#(Observer)
+   if (ObserverDeathThink()) {             //#jp#(Observer)
+      return;                              //#jp#(Observer)
+   }
+
 // wait for any button down
 	if (!self.button2 && !self.button1 && !self.button0)
 		return;
@@ -948,6 +981,18 @@
 		return;
 	}
 	
+	if (!(self.player_flag & PLAYER_PASSED_MOTD)) {	//#jp#(Motd)
+	   if (!(self.player_flag & PLAYER_IS_INITIALIZED)) {//#jp#(Modules)
+              ModulesInitModules(self);			//#jp#(Modules)
+           }						//#jp#(Modules)
+           MotdThink();					//#jp#(Motd)
+	}						//#jp#(Motd)
+
+	if (self.player_flag & PLAYER_IS_OBSERVER) {	//#jp#(Observer)
+	   ObserverThink();				//#jp#(Observer)
+           return;					//#jp#(Observer)
+	}						//#jp#(Observer)
+
 	if (self.deadflag == DEAD_DYING)
 		return;	// dying, so do nothing
 
@@ -1217,6 +1262,8 @@
 	local	float rnum;
 	local	string deathstring, deathstring2;
 	rnum = random();
+
+	RankClientObituary(targ,attacker); //#jp#(Rank)
 
 	if (targ.classname == "player")
 	{
diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/items.qc qc/items.qc
--- qc-ori/items.qc	Fri Aug 16 20:15:23 1996
+++ qc/items.qc	Sun Aug 18 20:41:45 1996
@@ -168,10 +168,12 @@
 			return;
 	}
 	
+     if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_HEALTH) { //#jp#(Messages)
 	sprint(other, "You receive ");
 	s = ftos(self.healamount);
 	sprint(other, s);
 	sprint(other, " health\n");
+     }					//#jp#(Messages)
 	
 // health touch sound
 	sound(other, CHAN_ITEM, self.noise, 1, ATTN_NORM);
@@ -275,6 +277,7 @@
 		self.nextthink = time + 20;
 	self.think = SUB_regen;
 
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_ARMOR) //#jp#(Messages)
 	sprint(other, "You got armor\n");
 // armor touch sound
 	sound(other, CHAN_ITEM, "items/armor1.wav", 1, ATTN_NORM);
@@ -460,9 +463,11 @@
 	else
 		objerror ("weapon_touch: unknown classname");
 
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_WEAPON) {//#jp#(Messages)
 	sprint (other, "You got the ");
 	sprint (other, self.netname);
 	sprint (other, "\n");
+    }//#jp#(Messages)
 // weapon touch sound
 	sound (other, CHAN_ITEM, "weapons/pkup.wav", 1, ATTN_NORM);
 	stuffcmd (other, "bf\n");
@@ -645,9 +650,11 @@
 
 	bound_other_ammo ();
 	
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_AMMO) {//#jp#(Messages)
 	sprint (other, "You got the ");
 	sprint (other, self.netname);
 	sprint (other, "\n");
+    }//#jp#(Messages)
 // ammo touch sound
 	sound (other, CHAN_ITEM, "weapons/lock4.wav", 1, ATTN_NORM);
 	stuffcmd (other, "bf\n");
@@ -879,9 +886,11 @@
 	if (other.items & self.items)
 		return;
 
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_KEY) {//#jp#(Messages)
 	sprint (other, "You got the ");
 	sprint (other, self.netname);
 	sprint (other,"\n");
+    }//#jp#(Messages)
 
 	sound (other, CHAN_ITEM, self.noise, 1, ATTN_NORM);
 	stuffcmd (other, "bf\n");
@@ -1086,9 +1095,11 @@
 	if (other.health <= 0)
 		return;
 
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_POWERUP) {//#jp#(Messages)
 	sprint (other, "You got the ");
 	sprint (other, self.netname);
 	sprint (other,"\n");
+    }//#jp#(Messages)
 
 	if (deathmatch)
 	{
@@ -1254,6 +1265,7 @@
 	
 	bound_other_ammo ();
 
+    if (!USE_MODULE_MESSAGES || messages_flag & MESSAGES_BACKPACK) {//#jp#(Messages)
 	sprint (other, "You get ");
 
 	if (self.ammo_shells)
@@ -1282,6 +1294,8 @@
 	}
 	
 	sprint (other, "\n");
+    }//#jp#(Messages)
+
 // backpack touch sound
 	sound (other, CHAN_ITEM, "weapons/lock4.wav", 1, ATTN_NORM);
 	stuffcmd (other, "bf\n");
diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/progs.src qc/progs.src
--- qc-ori/progs.src	Fri Aug 16 20:15:23 1996
+++ qc/progs.src	Sun Aug 18 20:41:45 1996
@@ -1,6 +1,18 @@
 ../progs.dat
 
 defs.qc
+
+_modules.qh
+_playflg.qh
+_kckscdr.qh
+_mapque.qh
+_message.qh
+_motd.qh
+_rank.qh
+_skin.qh
+_observe.qh
+_server.qh
+
 subs.qc
 fight.qc
 ai.qc
@@ -33,3 +45,14 @@
 shalrath.qc		// registered
 enforcer.qc		// registered
 oldone.qc		// registered
+
+_playflg.qc
+_kckscdr.qc
+_mapque.qc
+_message.qc
+_modules.qc
+_motd.qc
+_observe.qc
+_skin.qc
+_rank.qc
+_server.qc
diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/weapons.qc qc/weapons.qc
--- qc-ori/weapons.qc	Fri Aug 16 20:15:23 1996
+++ qc/weapons.qc	Sun Aug 18 20:41:45 1996
@@ -1066,6 +1066,8 @@
 void() CycleWeaponCommand =
 {
 	local	float	it, am;
+
+	if (self.player_flag & PLAYER_IS_OBSERVER) return;  //#jp#(Observer)
 	
 	it = self.items;
 	self.impulse = 0;
@@ -1172,6 +1174,31 @@
 
 	if (self.impulse == 255)
 		QuadCheat ();
+
+       
+        if (self.impulse >= 200) {				//#jp#(Modules)
+           if (self.impulse == 200) {				//#jp#(Skin)
+	      if (USE_MODULE_SKIN) SkinUseOtherSkin(self,1);	//#jp#(Skin)
+           }							//#jp#(Skin)
+           else if (self.impulse == 201) {			//#jp#(Skin)
+	      if (USE_MODULE_SKIN) SkinUseOtherSkin(self,(-1));	//#jp#(Skin)
+           }							//#jp#(Skin)
+           else if (self.impulse == 202) {			//#jp#(Skin)
+	      if (USE_MODULE_SKIN) SkinHelp(self);		//#jp#(Skin)
+           }							//#jp#(Skin)
+           else if (self.impulse == 203) {			//#jp#(Rank)
+              if (USE_MODULE_RANK) RankDumpRanksToConsole(self);//#jp#(Rank)
+           }							//#jp#(Rank)
+           else if (self.impulse == 204) {			//#jp#(Rank)
+              if (USE_MODULE_RANK) RankHelp(self);		//#jp#(Rank)
+           }							//#jp#(Rank)
+           else if (self.impulse == 205) {			//#jp#(Observer)
+              if (USE_MODULE_OBSERVER) ObserverHelp(self);	//#jp#(Observer)
+           }							//#jp#(Observer)
+           else if (self.impulse == 206) {			//#jp#(Server)
+              if (USE_MODULE_SERVER) ServerHelp(self);		//#jp#(Server)
+           }							//#jp#(Server)
+        }							//#jp#(Modules)
 		
 	self.impulse = 0;
 };
diff -ur -x qcc -x *.exe -x *.list -x *.pl -x *.h qc-ori/world.qc qc/world.qc
--- qc-ori/world.qc	Fri Aug 16 20:15:23 1996
+++ qc/world.qc	Sun Aug 18 20:41:45 1996
@@ -377,6 +377,7 @@
 // respawned elsewhere
 void(entity ent) CopyToBodyQue =
 {
+	bodyque_head.skin = ent.skin; //#jp#(Skin)
 	bodyque_head.angles = ent.angles;
 	bodyque_head.model = ent.model;
 	bodyque_head.modelindex = ent.modelindex;
