diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/ai.qc friend/ai.qc
--- v101qc/ai.qc	Thu Jul 25 01:51:22 1996
+++ friend/ai.qc	Wed Jul 31 21:52:51 1996
@@ -13,7 +13,7 @@
 The next path spot to walk toward.  If .enemy, ignore .movetarget.
 When an enemy is killed, the monster will try to return to it's path.
 
-.huntt_ime
+.hunt_time
 Set to time + something when the player is in sight, but movement straight for
 him is blocked.  This causes the monster to use wall following code for
 movement direction instead of sighting on the player.
@@ -326,12 +326,29 @@
 		sight_entity_time = time;
 	}
 	
-	self.show_hostile = time + 1;		// wake up other monsters
+	if(self.enemy!=self.friend) 
+		self.show_hostile = time + 1;	// wake up other monsters
+//	else {
+//		dprint(self.classname);
+//		dprint(" has a friend, ");
+//		dprint(self.friend.classname);
+//		dprint(".\n");
+//	}
 
 	SightSound ();
 	HuntTarget ();
 };
 
+void() FriendMove = 
+{
+	local float dir;
+
+	if(other != self.friend) return; // We don't want someone else pushing
+	dir = vectoyaw(other.velocity);
+	dir_z = dir_z+1;
+	walkmove(dir, 7);
+};
+
 /*
 ===========
 FindTarget
@@ -349,9 +366,11 @@
 slower noticing monsters.
 ============
 */
+void(entity newfriend) player_addfriend;
+
 float() FindTarget =
 {
-	local entity	client;
+	local entity	client, oldself;
 	local float		r;
 
 // if the first spawnflag bit is set, the monster will only wake up on
@@ -413,6 +432,15 @@
 		}
 	}
 	
+	if(self.flags & FL_FRIENDLY || self.classname == "monster_dog" ) {
+		self.touch=FriendMove;
+		self.friend=self.enemy;
+		oldself=self;
+		self=self.friend;
+		player_addfriend(oldself);
+		self=oldself;
+	}
+
 	FoundTarget ();
 
 	return TRUE;
@@ -499,12 +527,21 @@
 */
 void() ai_stand =
 {
+	local float r;
 	if (FindTarget ())
 		return;
 	
 	if (time > self.pausetime)
 	{
-		self.th_walk ();
+		if(self.friend) {
+			r=range(self.friend);
+			if(r==RANGE_MELEE)
+				return;
+			else if(r==RANGE_MID)
+				self.th_walk ();
+			else
+				self.th_run ();
+		}
 		return;
 	}
 	
@@ -677,12 +714,22 @@
 void(float dist) ai_run =
 {
 	local	vector	delta;
+	local	float	test;
 	local	float	axis;
 	local	float	direct, ang_rint, ang_floor, ang_ceil;
 	
 	movedist = dist;
 // see if the enemy is dead
-	if (self.enemy.health <= 0)
+	if (self.classname == "monster_dog"
+		|| self.classname == "monster_shambler"
+		|| self.classname == "monster_demon") 
+		// Those guys are viscious
+			test=1;
+	else {
+		test = (self.enemy.flags & FL_MONSTER) == FL_MONSTER;
+		test = test + (self.enemy.classname == "player");
+	}
+	if (!test || self.enemy.health <= 0)
 	{
 		self.enemy = world;
 	// FIXME: look all around for other targets
@@ -693,7 +740,14 @@
 		}
 		else
 		{
-			if (self.movetarget)
+			if (self.friend)
+				if(self.friend.health > 0) {
+					self.enemy = self.friend;
+					HuntTarget();
+				} else {
+					self.friend=world;
+				}
+			else if (self.movetarget)
 				self.th_walk ();
 			else
 				self.th_stand ();
@@ -701,12 +755,24 @@
 		}
 	}
 
-	self.show_hostile = time + 1;		// wake up other monsters
 
 // check knowledge of enemy
 	enemy_vis = visible(self.enemy);
 	if (enemy_vis)
 		self.search_time = time + 5;
+
+// Okay, just find our friend
+	if(self.enemy == self.friend) {
+		// head straight in
+		if(range(self.friend) == RANGE_MELEE) {
+			self.pausetime=time+1;
+			self.th_stand();
+		} else
+			movetogoal (dist);		// done in C code...
+		return;
+	}
+		
+	self.show_hostile = time + 1;		// wake up other monsters
 
 // look for other coop players
 	if (coop && self.search_time < time)
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/client.qc friend/client.qc
--- v101qc/client.qc	Thu Jul 25 01:51:22 1996
+++ friend/client.qc	Wed Jul 31 21:37:35 1996
@@ -2,7 +2,7 @@
 // prototypes
 void () W_WeaponFrame;
 void() W_SetCurrentAmmo;
-void() player_pain;
+void(entity e, float f) player_pain;
 void() player_stand1;
 void (vector org) spawn_tfog;
 void (vector org, entity death_owner) spawn_tdeath;
@@ -57,7 +57,7 @@
 
 void() SetNewParms =
 {
-	parm1 = IT_SHOTGUN | IT_AXE;
+	parm1 = IT_SHOTGUN | IT_AXE | IT_EXTRA_WEAPON;
 	parm2 = 100;
 	parm3 = 0;
 	parm4 = 25;
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/defs.qc friend/defs.qc
--- v101qc/defs.qc	Thu Jul 25 01:51:22 1996
+++ friend/defs.qc	Wed Jul 31 21:37:35 1996
@@ -240,6 +240,7 @@
 float	FL_PARTIALGROUND		= 1024;	// not all corners are valid
 float	FL_WATERJUMP			= 2048;	// player jumping out of water
 float	FL_JUMPRELEASED			= 4096;	// for jump debouncing
+float	FL_FRIENDLY			= 8192;
 
 // edict.movetype values
 float	MOVETYPE_NONE			= 0;	// never moves
@@ -690,4 +691,6 @@
 
 float(entity targ, entity inflictor) CanDamage;
 
-
+.entity	friend;
+.entity friendlist;
+.entity	listitem;
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/jeffqc.txt friend/jeffqc.txt
--- v101qc/jeffqc.txt	Wed Dec 31 18:00:00 1969
+++ friend/jeffqc.txt	Wed Jul 31 21:37:35 1996
@@ -0,0 +1,153 @@
+START WITH SOME LEGALESE:
+
+Please distribute this code only in accordance with Id's license.  Since it
+is a modified version of a part of Registered Quake, this means there are
+certain things you can't do with it.  But using it with your copy of
+Registered Quake is one of the things that is allowed.  (While not exactly a
+custom level or level editor software, id has implied that this sort of thing
+is an acceptable derivative work by releasing qcc.)
+
+
+WHAT THIS IS:
+
+This is the fourth release of my altered QuakeC system.  Child of SOLIDDOG,
+SOLIDMON, and SOLIDMN2, it's changed its name to JEFFQC in order to reflect
+the fact that it's more than just solid monsters now.
+
+Solid monsters:
+
+I've seen people complain on rec.games.computer.quake.* that the monsters
+become ghostlike after death -- You can walk right through them, can't
+shoot them, etc.  This annoyed me too.  So, I wrote spent this first day
+after the release of QuakeC changing this.
+
+When a monster dies, it falls down, may discharge some ammo, and lays
+there.  Now, the laying monster can be hit, and eventually it gibs.  To
+make this even more satisfying, I added a flesh-impact sound to the axe
+chop (really a zombie sound) -- Kill that shambler and then hack it to
+bits!  Or tear into a dead body with the super perforator and watch the
+gibs fly.  (This is impressive, but not quite believeable)
+
+When playing in God mode, I saw a shambler get mad at a scrag.  He killed
+it, and then proceeded to hack the body to death before going on to his
+next assailant.  This was pretty cool to watch.
+
+Shamblers, demons and dogs will rip at dead bodies till they gib.  I should
+change it so they only do this until they have a better target (ie someone
+shoots them -- OTOH, this way it's cool to lure the shambler into killing a
+scrag on E1L3 and then tearing into him with no fear while he works on the
+corpse)
+
+I haven't added pushable corpses, because I'm just plain lazy.
+
+Friends/Helpers/Assistants:
+
+The second biggest requested feature is a monster who goes along with you
+and beats up on your enemies.  I've added that in this release of my QuakeC
+programs.  As shipped, dogs and monsters with FL_FRIENDLY (8192) are
+friendly to whatever player they see first.  Just fire up quake with this
+progs.dat and enter e1m1.  In the "room" with the bridge, stand and let the
+grunt fire at you.  The dog will notice that you're in danger and leap at
+the grunt, usually managing to kill him.  Your friends will follow you
+around, and can be pushed out of the way. (though not off the edge of
+platforms)
+
+Just because they're your friends doesn't mean they're any smarter than
+regular monsters.  I've seen one dog eat right through another to get to
+the enemy it was looking for.  They also don't get mad at you, even if you
+take the axe to them.
+
+WHAT STILL NEEDS TO BE DONE:
+
+The dead monsters may need their bounding boxes changed -- I just shortened
+them some, so that most monster bodies can merely be walked across.
+Unfortunately, it's more of a glide across.  I don't know if this can be
+fixed..
+
+I haven't tackled the player object.  I was also thinking of adding a
+gib-and-teleport effect when a player gets his new body.  But I don't dm
+much, and am afraid of breaking something.
+
+The fish and tarbaby are just like before.  They don't have gib animations 
+and are written a little different.  Besides, I haven't played far enough
+to run into them yet.
+
+The bodies themselves stay the same between death and gibbed-to-pieces.
+It'll be this way unless somebody designs models with arms, legs, etc
+chopped off.  A tall order.
+
+Steal the ideas from other people's solid monster code.
+
+HOW TO TRY THIS OUT:
+
+I've enclosed a PROGS.DAT file generated from my modified .qc files, as
+well as the whole .qc source.  (Ah, if only this were unix .. I'd give you
+diff -u format instead)
+
+IF YOU WANT TO MAKE THE PROGS.DAT YOURSELF:
+
+Get quakec from ftp://ftp.idsoftware.com/idstuff/source/qcc.tar.gz
+You can use winzip to open it up, or unix tar and gzip.  There are also
+versions of gzip (different from pkzip and info-zip) and tar for dos, look
+around on ftp://oak.oakland.edu/pub/simtelnet/msdos for one.  Someone will
+probably package qccdos.exe and the .qc source files by themselves soon.
+
+Run QCCDOS from the directory where you put my qc files.  You'll end up with
+PROGS.DAT in the directory where QCCDOS.EXE resides.  Now continue on
+below.
+
+IF YOU WANT TO JUST USE MY PROGS.DAT:
+
+Make a directory in your quake registered directory (For instance,
+C:\GAMES\QUAKE) called SOLID.  Then copy the PROGS.DAT file into SOLID.
+
+Run quake with
+ QUAKE -game solid
+and go play with the nice little doggies who live on that level.
+
+
+ABOUT MY CODE:
+
+I modified the various <monster>.qc files, the weapons.qc file, and added
+jsubs.qc.  The idea is this:
+
+When a monster dies, don't set it "SOLID_NOT".  Instead, set all its
+actions to nothing, assign a new health number and a new death function
+that gibs the creature.  You now have a creature that's solid and
+destroyable after death.  Turn off its FL_CREATURE flag so its death isn't
+counted twice.
+
+In each case, the code added to *_die is about the same for each monster,
+and the code in *_really_die is very similar to the gib code that was
+formerly inside _die.
+
+I discovered a really neat way to make a monster invincible:  Set it
+DAMAGE_NO.  Imagine a monster that's only vulnerable at certain moments,
+such as when it's about to fire at you ...
+
+Quake C seems to not be too difficult to program (though I don't think I
+can create entities from scratch just yet) and it seems pretty powerful.
+Having played with this, I just got a lot more impressed about the
+possibilities Quake should offer those who are working to extend it with
+their own ideas.
+
+
+
+THANKS TO
+
+id, for the game and all the openness about it.  Now, hurry up with the
+linux version! (If you care too, mail johnc@idsoftware.com about it)
+
+My girlfriend, for patiently ignoring me when I tried to explain how cool
+it was to hack up dead bodies.
+
+
+GIVE ME FEEDBACK:
+
+Please mail me with your thoughts about this quick quake hack. (try saying
+that three times fast!)  It may not be as glamorous as level editing, but
+I like it.
+
+Jeff Epler
+(jepler@inetnebr.com, Synger on IRC (linuxnet and undernet, primarily))
+30 July 1996
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/llsubs.qc friend/llsubs.qc
--- v101qc/llsubs.qc	Wed Dec 31 18:00:00 1969
+++ friend/llsubs.qc	Wed Jul 31 21:37:35 1996
@@ -0,0 +1,40 @@
+entity(float size) SUB_Llinit =
+{
+	local float i=0;
+	local entity head, current;
+	head=world;
+	while(i<size) {
+		current=spawn();
+		current.chain=head;
+		head=current;
+	}
+	return head;
+};
+
+		
+entity(entity list, float index) SUB_Llaccess =
+{
+	local float i=0;
+	local entity here;
+	here=list;
+	while(i<index&&here!=world) {
+		here=here.chain;
+	}
+	return here.ent;
+};
+	
+void(void (entity e) f, entity list) SUB_Lliter =
+{
+	while(list!=world) {
+		f(list.ent);
+		list=list.chain;
+	}
+};
+
+entity(float (entity e) f, entity list) SUB_Llfind =
+{
+	while(list!=world) {
+		if (f(list.ent)) return list.ent;
+		list=list.chain;
+	}
+};
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/p_af.s friend/p_af.s
--- v101qc/p_af.s	Wed Dec 31 18:00:00 1969
+++ friend/p_af.s	Wed Jul 31 21:37:36 1996
@@ -0,0 +1,54 @@
+outputfile: ../progs.dat
+compiling defs.qc
+compiling subs.qc
+compiling fight.qc
+compiling ai.qc
+compiling combat.qc
+compiling items.qc
+compiling weapons.qc
+compiling world.qc
+compiling client.qc
+compiling player.qc
+compiling jsubs.qc
+compiling monsters.qc
+compiling doors.qc
+compiling buttons.qc
+compiling triggers.qc
+compiling plats.qc
+compiling misc.qc
+compiling ogre.qc
+compiling demon.qc
+compiling shambler.qc
+compiling knight.qc
+compiling soldier.qc
+compiling wizard.qc
+compiling dog.qc
+compiling zombie.qc
+compiling boss.qc
+compiling tarbaby.qc
+compiling hknight.qc
+compiling fish.qc
+compiling shalrath.qc
+compiling enforcer.qc
+compiling oldone.qc
+Statements for player_addfriend:
+8212 :  626 : CALL0      460(spawn)       
+8213 :  626 : STORE_ENT  1(temp)          5309(newfle)     
+8214 :  627 : ADDRESS    5309(newfle)     164(chain)       5310(???)        
+8215 :  627 : INDIRECT   28(self)         525(friendlist)  5311(???)        
+8216 :  627 : STOREP_ENT 5311(???)        5310(???)        
+8217 :  628 : ADDRESS    5309(newfle)     526(listitem)    5312(???)        
+8218 :  628 : STOREP_ENT 5308(e)          5312(???)        
+8219 :  629 : ADDRESS    28(self)         525(friendlist)  5313(???)        
+8220 :  629 : STOREP_ENT 5309(newfle)     5313(???)        
+8221 :  630 : DONE       
+writing progdefs.h
+ 88748 strofs
+ 21251 numstatements
+  2104 numfunctions
+  4315 numglobaldefs
+   221 numfielddefs
+ 11646 numpr_globals
+417432 TOTAL SIZE
+225 unique precache_sounds
+ 95 unique precache_models
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/player.qc friend/player.qc
--- v101qc/player.qc	Thu Jul 25 01:51:23 1996
+++ friend/player.qc	Wed Jul 31 21:37:36 1996
@@ -334,8 +334,40 @@
 void()	player_axpain5 =	[	$axpain5,	player_axpain6	] {};
 void()	player_axpain6 =	[	$axpain6,	player_run	] {};
 
-void() player_pain =
+void(entity attacker, float take) player_pain =
 {
+	local entity list, previous, onefriend;
+	local entity oldself;
+
+	list=self.friendlist;
+	previous=world;
+	while(list) {
+		onefriend=list.listitem;
+		if(onefriend.friend!=self||onefriend.health <=0) {
+			if(onefriend.health <= 0) {
+				if(previous) {
+					previous.chain=list.chain;
+					remove(list);
+					list=previous.chain;
+				} else {
+					self.friendlist=list.chain;
+					remove(list);
+					list=self.friendlist;
+				}
+			}
+		} else {
+			if(onefriend.enemy==onefriend.friend) {
+				onefriend.enemy=attacker;
+				oldself=self;
+				self=onefriend;
+				FoundTarget();
+				self=oldself;
+			}
+			previous=list;
+			list=list.chain;
+		}
+	}
+
 	if (self.weaponframe)
 		return;
 
@@ -589,6 +621,13 @@
 	self.nextthink = -1;
 };
 
+void(entity e) player_addfriend = {
+	local entity newfle;
+	newfle=spawn();
+	newfle.chain=self.friendlist;
+	newfle.listitem=e;
+	self.friendlist=newfle;
+};
 
 void()	player_diea1	=	[	$deatha1,	player_diea2	] {};
 void()	player_diea2	=	[	$deatha2,	player_diea3	] {};
diff -ur --new-file -x progs.dat -x progdefs.h -x *.bak -x *~ -x *.rej v101qc/solidmon.txt friend/solidmon.txt
--- v101qc/solidmon.txt	Wed Dec 31 18:00:00 1969
+++ friend/solidmon.txt	Wed Jul 31 21:37:52 1996
@@ -0,0 +1,125 @@
+START WITH SOME LEGALESE:
+
+Please distribute this code only in accordance with Id's license.  Since it
+is a modified version of a part of Registered Quake, this means there are
+certain things you can't do with it.  But using it with your copy of
+Registered Quake is one of the things that is allowed.  (While not exactly a
+custom level or level editor software, id has implied that this sort of thing
+is an acceptable derivative work by releasing qcc.)
+
+
+WHAT THIS IS:
+
+This is the second release of solidmon, since the first time I packaged an
+incorrect progs.dat.  Sorry about that folks!
+
+I've seen people complain on rec.games.computer.quake.* that the monsters
+become ghostlike after death -- You can walk right through them, can't
+shoot them, etc.  This annoyed me too.  So, I wrote spent this first day
+after the release of QuakeC changing this.
+
+When a monster dies, it falls down, may discharge some ammo, and lays
+there.  Now, the laying monster can be hit, and eventually it gibs.  To
+make this even more satisfying, I added a flesh-impact sound to the axe
+chop (really a zombie sound) -- Kill that shambler and then hack it to
+bits!  Or tear into a dead body with the super perforator and watch the
+gibs fly.  (This is impressive, but not quite believeable)
+
+When playing in God mode, I saw a shambler get mad at a scrag.  He killed
+it, and then proceeded to hack the body to death before going on to his
+next assailant.  This was pretty cool to watch.
+
+
+WHAT STILL NEEDS TO BE DONE:
+
+The dead monsters may need their bounding boxes changed -- I just shortened
+them some, so that most monster bodies can merely be walked across.
+Unfortunately, it's more of a glide across.  I don't know if this can be
+fixed..
+
+I haven't tackled the player object.  I was also thinking of adding a
+gib-and-teleport effect when a player gets his new body.  But I don't dm
+much, and am afraid of breaking something.
+
+The fish and tarbaby are just like before.  They don't have gib animations 
+and are written a little different.  Besides, I haven't played far enough
+to run into them yet.
+
+The bodies themselves stay the same between death and gibbed-to-pieces.
+It'll be this way unless somebody designs models with arms, legs, etc
+chopped off.  A tall order.
+
+
+HOW TO TRY THIS OUT:
+
+I've enclosed a PROGS.DAT file generated from my modified .qc files, as
+well as the whole .qc source.  (Ah, if only this were unix .. I'd give you
+diff -u format instead)
+
+IF YOU WANT TO MAKE THE PROGS.DAT YOURSELF:
+
+Get quakec from ftp://ftp.idsoftware.com/idstuff/source/qcc.tar.gz
+You can use winzip to open it up, or unix tar and gzip.  There are also
+versions of gzip (different from pkzip and info-zip) and tar for dos, look
+around on ftp://oak.oakland.edu/pub/simtelnet/msdos for one.  Someone will
+probably package qccdos.exe and the .qc source files by themselves soon.
+
+Run QCCDOS from the directory where you put my qc files.  You'll end up with
+PROGS.DAT in the directory where QCCDOS.EXE resides.  Now continue on
+below.
+
+IF YOU WANT TO JUST USE MY PROGS.DAT:
+
+Make a directory in your quake registered directory (For instance,
+C:\GAMES\QUAKE) called SOLID.  Then copy the PROGS.DAT file into SOLID.
+
+Run quake with
+ QUAKE -game solid
+and go play with the nice little doggies who live on that level.
+
+
+ABOUT MY CODE:
+
+I modified the various <monster>.qc files, the weapons.qc file, and added
+jsubs.qc.  The idea is this:
+
+When a monster dies, don't set it "SOLID_NOT".  Instead, set all its
+actions to nothing, assign a new health number and a new death function
+that gibs the creature.  You now have a creature that's solid and
+destroyable after death.  Turn off its FL_CREATURE flag so its death isn't
+counted twice.
+
+In each case, the code added to *_die is about the same for each monster,
+and the code in *_really_die is very similar to the gib code that was
+formerly inside _die.
+
+I discovered a really neat way to make a monster invincible:  Set it
+DAMAGE_NO.  Imagine a monster that's only vulnerable at certain moments,
+such as when it's about to fire at you ...
+
+Quake C seems to not be too difficult to program (though I don't think I
+can create entities from scratch just yet) and it seems pretty powerful.
+Having played with this, I just got a lot more impressed about the
+possibilities Quake should offer those who are working to extend it with
+their own ideas.
+
+
+
+THANKS TO
+
+id, for the game and all the openness about it.  Now, hurry up with the
+linux version! (If you care too, mail johnc@idsoftware.com about it)
+
+My girlfriend, for patiently ignoring me when I tried to explain how cool
+it was to hack up dead bodies.
+
+
+GIVE ME FEEDBACK:
+
+Please mail me with your thoughts about this quick quake hack. (try saying
+that three times fast!)  It may not be as glamorous as level editing, but
+I like it.
+
+Jeff Epler
+(jepler@inetnebr.com, Synger on IRC (linuxnet and undernet, primarily))
+25 July 1996
